Leetcode Container With Most Water

Given n non-negative integers a1, a2, ..., an, where each represents a point at coordinate (i, ai). n vertical lines are drawn such that the two endpoints of line i is at (i, ai) and (i, 0). Find two lines, which together with x-axis forms a container, such that the container contains the most water.

Note: You may not slant the container.


Idea:

Simplest way is enumerating all possible combination. Time complexity is O(N^2), which is too large.

Another solution is two pointer.  First make two pointer left and right point to 0 and len-1 of the array.

Compare height[left] and height(right), If height[left] > height(right), we know height[right] is the bottleneck. Calculate (right-left)*height[right]. Now we are sure that  for every rectangle ends in right = len-1, the area contained must be less than (right-left)*height[right], since that the width must be less than (right-left) while the height bottleneck cannot be larger that height[right].

If height[left] <= height(right), calculate (right-left)*height[left]. Now we are sure that  for every rectangle starts in left=0, the area contained must be less than (right-left)*height[left], since that the width must be less than right-left while height bottleneck cannot be larger than height[left].

Next narrow down the target rectangle width. We narrow down in the bottleneck position. That is, if height[left] > height(right), right--, otherwise left++.

When left and right meets we can stop, and the current max rectangle is the result we want.

code:

public class Solution {
    public int maxArea(int[] height) {
        int left = 0;
        int right = height.length-1;
        int max = 0;
        while(left<right){
            if(height[left]<height[right]){
                max = Math.max(max, (right-left)*height[left]);
                left++;
            }else{
                max = Math.max(max, (right-left)*height[right]);
                right--;
            }
        }
        return max;
    }
}

time complexity is O(n), space complexity is constant. But this code cannot pass leetcode large test case. Rewrite in C++ it passes

class Solution {
public:
    int maxArea(vector<int>& height) {
        int left = 0;
        int right = height.size()-1;
        int res = 0;
        while(left<right){
            if(height[left]>height[right]){
                res = max(res, (right-left)*height[right]);
                right--;
            }else{
                res = max(res, (right-left)*height[left]);
                left++;
            }
        }
        return res;
    }
};


  • 0
    点赞
  • 0
    收藏
    觉得还不错? 一键收藏
  • 0
    评论
评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值